#ifndef _FILEIO_UTIL_H
#define _FILEIO_UTIL_H
#include "general.h"

#include <stdio.h>

/* print out program header */
void fprint_signature(FILE *fp);

/* Search a keyword within *str */
int keymatch(char *str, char *keyword) ;

void fileio_util_perror(char *reason) ;

/* File open/close that handles "-" as stdin and checks errors. */
FILE* fileio_util_openr(char *name) ;
FILE* fileio_util_openw(char *name) ;
void fileio_util_close(FILE *f) ;

/* STR_LNG and ABS_STR_LNG are used in getline() */
#ifdef STR_LNG
#undef STR_LNG
#endif
#define STR_LNG     BUFSIZ

#ifndef ABS_STR_LNG
/*
#define ABS_STR_LNG 32768
*/
#define ABS_STR_LNG (32768 * 16)
#endif

/* Get a line from input stream, 
   if the input stream is illegal, then return NULL */
char *getline(FILE *fp);

#endif _FILEIO_UTIL_H
