#ifndef _MTF_H_
#define _MTF_H_
#include "general.h"
#include "matrix_util.h"

/*---------------------
  defined in mtf_sub.c 
  ---------------------*/
vector gen_distance_table(int center, double scale, double mink);
double calc_distance(int i, int j, int rows_center, int cols_center, vector distr, vector distc, double mink);

/*---------------------
  define in idealMTF.c
  ---------------------*/
double modulate_idealMTF(double distance, double band_center, double low, double high);
matinfo gen_idealMTF(int n, int m,  double band_center, double low, double high, int col_stand, double mink);

/*---------------------
  define in exponentialMTF.c
  ---------------------*/
double modulate_exponentialMTF(double distance, double band_center, double low, double high);
matinfo gen_exponentialMTF(int n, int m,  double band_center, double low, double high, int col_stand, double mink);

#endif _MTF_H_
