/* Compute a correlation matrix 

   Copyright (c) 1999 Shinichi ASAKAWA <asakawa@twcu.ac.jp>

   Disclaimer:  No guarantees of performance accompany this software,
   nor is any responsibility assumed on the author.  */
#include <stdlib.h>
#include <math.h>
#include "matrix_util.h"
#include "fileio_util.h"
#include <stdio.h>

int usage(char *prgname)
{
    printf("%s \n", prgname);
    printf("Usage %s [datafile]\n", prgname);
    exit (EXIT_FAILURE);
}

int main(int argc, char **argv)
{
    int n = 0, m = 0, argn = 1;
    matrix A, Cov = NULL;
    matinfo Ainfo;
    
    while (argn < argc && argv[argn][0] == '-' && argv[argn][1] != '\0') {
        if (keymatch(argv[argn], "--help")) { usage(argv[0]); }
        if (keymatch(argv[argn], "-h")) { usage(argv[0]); }
        ++argn;
    }
    if (argn != argc) {
        Ainfo = matinfo_read( argv[argn] );
    } else {
        Ainfo = matinfo_read("-");
    }
    A = Ainfo->mat;
    n = Ainfo->n; m = Ainfo->m;

    Cov = matCov(A, n, m);
    fprintf(stdout, "### ProgramName: %s %s\n", argv[0], Ainfo->name);
    fprint_signature(stdout);
    fprintf(stdout, "### DataSize: %d %d\n", m, m);
    fwritemat(stdout, Cov, m, m, "", "");
    return OK;
}
