/*
 * @(#)matcpy.c - matrix operate function 1.02 (Shinichi Asakawa) 21-07-1990
 */
#include <stdlib.h>
#include "matrix_util.h"
#include "fileio_util.h"

/*--- Copy a matrix(From) to another(To) matrix ---*/
int matcpy(matrix  From, int fn, int fm, matrix To)
{
    if ( To == NULL ){
	if ((To = matinit(fn, fm)) == NULL) {
	    fileio_util_perror("Could not allocate memory in matcpy()");
	    exit (EXIT_FAILURE);
	}
    }
    
    if (memcpy((void *)To, (void *)From, (fn * fm) * sizeof(double)) == NULL) {
        fprintf(stderr,"Error in matcpy\n");
        exit (EXIT_FAILURE);
    }
    return OK;
}


/*--- Return A ---*/
matrix matCpy(matrix A, int an, int am) 
{
    matrix Ret;

    if ((Ret = matinit(an, am)) == NULL) {
	fileio_util_perror("Could not allocate memory in matCpy()");
	exit (EXIT_FAILURE);
    }
    if (memcpy((void *)Ret, (void *)A, (an * am) * sizeof(double)) == NULL) {
        fprintf(stderr,"Error in matCpy()\n");
        exit (EXIT_FAILURE);
    }
    return Ret;
}
