/*
 * @(#)matproject.c - matrix operate function 1.02 (Shinichi Asakawa) 21-07-1990
 */
#include <stdlib.h>
#include "matrix_util.h"
#include "fileio_util.h"

/* get a projection matrix, whose space has been consisted of a matrix A */
int matproject (matrix A, int n, int m, matrix Ret)
{
    matrix AtAinvAt;

    if ( Ret == NULL ) {
	fprintf(stderr, "Invalid Ret matrix in matproject()\n");
	exit (EXIT_FAILURE);
    }

    if ( A == NULL ) {
	fprintf(stderr, "Invalid matrix  in matproject()\n");
	exit (EXIT_FAILURE);
    }

    AtAinvAt = matSqinvmatt(A,n,m);
    matprd(A,n,m,AtAinvAt,m,n,Ret);
    free(AtAinvAt);
    return OK;
}

matrix matProject (matrix A, int n, int m)
{
    matrix AtAinvAt, Ret;

    if ( A == NULL ) {
	fprintf(stderr, "Invalid matrix  in matProject()\n");
	exit (EXIT_FAILURE);
    }
    AtAinvAt = matSqinvmatt(A,n,m);
    Ret = matPrd(A,n,m,AtAinvAt,m,n);
    free(AtAinvAt);
    return Ret;
}

/* 
 * get an inverse projection matrix, whose space has been consisted of a matrix A
 */
int matiproject(matrix A, int n, int m, matrix Ret)
{
    matrix P, I;

    if ( Ret == NULL ) {
	fprintf(stderr, "Invalid Ret matrix in matproject()\n");
	exit (EXIT_FAILURE);
    }
    P = matProject(A,n,m);
    I = matI(n);
    matsub(I,n,n,P,n,n,Ret);
    free(P); free(I);
    return OK;
}

matrix matIproject(matrix A, int n, int m)
{
    matrix P,I, Ret;

    P = matProject(A,n,m);
    I = matI(n);
    Ret = matSub(I,n,n,P,n,n);
    free(P); free(I);
    return Ret;
}
