/* F$BJ,I[(B */
#include <math.h>
#include "general.h"
#include "rand_gen.h"

double F_rand(double n1, double n2)  
{
    return (chisq_rand(n1) * n2) / (chisq_rand(n2) * n1);
}


/**********************************************************/
#ifdef STANDALONE
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

long loadingtime;
unsigned int SEED = 0;

void Usage (char *prg) {
  fprintf(stderr,"Usage:\n");
  fprintf(stderr,"%s DF1 DF2 N [SEED]\n", prg);
  fprintf(stderr,"arguments  DF1: degree of freedom for F(1) distribution(double)\n");
  fprintf(stderr,"           DF2: degree of freedom for F(2) distribution(double)\n");
  fprintf(stderr,"           N: number of data to be generated(int)\n");
  fprintf(stderr,"           SEED: seed of random number(long int)\n");
  exit (EXIT_FAILURE);
}

int main (int argc, char **argv) {
    int i, max = 0;
    double df1=0.0, df2=0.0;

    SEED = (unsigned)time(&loadingtime);

    switch (argc) {
    case 4:
        df1 = atof(argv[1]);
        df2 = atof(argv[2]);
        max = (unsigned)atoi(argv[3]);
        break;
    case 5:	
        df1 = atof(argv[1]);
        df2 = atof(argv[2]);
        max = (unsigned)atoi(argv[3]);
        SEED = atof(argv[4]); 
        break;
    default:
	Usage(argv[0]); exit (EXIT_FAILURE);
    }
    if (max == 0)     Usage(argv[0]);
    if (df1 == 0.0)     Usage(argv[0]);
    if (df2 == 0.0)     Usage(argv[0]);
    MTsgenrand(SEED);

    fprintf(stdout, "### ProgramName: %s %g %g %d %d\n", argv[0], df1, df2, max, SEED);
    fprintf(stdout, "### Creator: Shinichi ASAKAWA <asakawa@twcu.ac.jp>\n");
    (void)time(&loadingtime);
    fprintf(stdout, "### CreationDate: %s", ctime(&loadingtime));

    for (i = 0; i < max; i++) {
	printf("%10.5f\n", F_rand(df1, df2));
    }
    return EXIT_SUCCESS;
}
#endif STANDALONE
