  /* 2$B9`J,I[(B */
#include <math.h>
#include "general.h"
#include "rand_gen.h"

int binomial_rand(int n, double p)
{
    int i, r;

    r = 0;
    for (i = 0; i < n; i++)
	if (MTgenrand_f() < p) r++;
    return r;
}

/**********************************************************/
#ifdef STANDALONE
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

long loadingtime;
unsigned int SEED = 0;

void Usage (char *prg) {
  fprintf(stderr,"Usage:\n");
  fprintf(stderr,"%s N Prob MAX [SEED]\n", prg);
  fprintf(stderr,"arguments  N: parameter for binomial distribution(int)\n");
  fprintf(stderr,"           Prob: probability for binomial distribution(double)\n");
  fprintf(stderr,"           MAX: number of data to be generated(int)\n");
  fprintf(stderr,"           SEED: seed of random number(long int)\n");
  exit (EXIT_FAILURE);
}

int main (int argc, char **argv) {
    int i, max = 0, n = 0;
    double prob=0.0;

    SEED = (unsigned)time(&loadingtime);

    switch (argc) {
    case 4:
        n = atoi(argv[1]);
        prob = atof(argv[2]);
        max = (unsigned)atoi(argv[3]);
        break;
    case 5:	
        n = atoi(argv[1]);
        prob = atof(argv[2]);
        max = (unsigned)atoi(argv[3]);
        SEED = atof(argv[4]); 
        break;
    default:
	Usage(argv[0]); exit (EXIT_FAILURE);
    }
    if (max == 0) Usage(argv[0]);
    if (n == 0) Usage(argv[0]);
    if (prob == 0.0)  Usage(argv[0]);
    MTsgenrand(SEED);

    fprintf(stdout, "### ProgramName: %s %d %g %d %d\n", argv[0], n, prob, max, SEED);
    fprintf(stdout, "### Creator: Shinichi ASAKAWA <asakawa@twcu.ac.jp>\n");
    (void)time(&loadingtime);
    fprintf(stdout, "### CreationDate: %s", ctime(&loadingtime));

    for (i = 0; i < max; i++) {
	printf("%7d\n", binomial_rand(n, prob));
    }
    return EXIT_SUCCESS;
}
#endif STANDALONE
