#include <math.h>
#include "general.h"
#include "rand_gen.h"

double Cauchy_rand1(void)  /* Cauchy ($B%3!<%7!<(B) $BJ,I[(B 1 */
{
    return tan(PI * MTgenrand_f());
}

double Cauchy_rand2(void)  /* Cauchy ($B%3!<%7!<(B) $BJ,I[(B 2 */
{
    double x, y;

    do {
        x = 1.0 - MTgenrand_f();  
        y = 2 * MTgenrand_f() - 1.0;
    } while (x * x + y * y > 1);
    return y / x;
}

double cauchy_rand (void)  
{
    return Cauchy_rand2();
}


/**********************************************************/
#ifdef STANDALONE
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

long loadingtime;
unsigned int SEED = 0;

void Usage (char *prg) {
  fprintf(stderr,"Usage:\n");
  fprintf(stderr,"%s N [SEED]\n\n", prg);
  fprintf(stderr,"arguments  N: num of data to be generated(int)\n");
  fprintf(stderr,"           SEED: seed of random number(long int)\n");
  exit (EXIT_FAILURE);
}

int main (int argc, char **argv) {
    int i, max = 0;

    SEED = (unsigned)time(&loadingtime);

    switch (argc) {
    case 2:
        max = (unsigned)atoi(argv[1]);
        break;
    case 3:
        max = (unsigned)atoi(argv[1]);
        SEED = atof(argv[2]); 
        break;
    default:
	Usage(argv[0]); exit (EXIT_FAILURE);
	/*
    	for (i=1; i<argc; i++){
            if (argv[i][0] == '-'){
                if (strcmp(argv[i],"-n") == 0) {
                    if (argv[++i] == NULL)  Usage(argv[0]);
                    max = (unsigned)atoi(argv[i]);
                } else if (strcmp(argv[i],"-SEED") == 0) {
                    if (argv[++i] == NULL)  Usage(argv[0]);
                    SEED = atof(argv[i]); 
                } else if (strcmp(argv[i],"-h") == 0) {
                    Usage(argv[0]);
                    exit (EXIT_FAILURE);
                }
            }
        }
	*/
    }
    if (max == 0)     Usage(argv[0]);
    MTsgenrand(SEED);

    fprintf(stdout, "### ProgramName: %s -n %d -SEED %d\n", argv[0], max, SEED);
    fprintf(stdout, "### Creator: Shinichi ASAKAWA <asakawa@twcu.ac.jp>\n");
    (void)time(&loadingtime);
    fprintf(stdout, "### CreationDate: %s", ctime(&loadingtime));

    for (i = 0; i < max; i++) {
	printf("%10.5f\n", cauchy_rand());
    }
    return EXIT_SUCCESS;
}
#endif STANDALONE
