/***********************************************************
	exp_rand.c -- ؿʬ
***********************************************************/
#include <math.h>
#include "general.h"
#include "rand_gen.h"

double exp_rand (void)  
{
    return -log(1.0 - MTgenrand_f());
}


/**********************************************************/
#ifdef STANDALONE
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

long loadingtime;
unsigned int SEED = 0;

void Usage (char *prg) {
  fprintf(stderr,"Usage:\n");
  fprintf(stderr,"%s N [SEED]\n or \n%s -n N -SEED SEED\n",prg,prg);
  fprintf(stderr,"options  -n: num of data to be generated(int)\n");
  fprintf(stderr,"         -SEED: seed of random number(long int)\n");
  exit (EXIT_FAILURE);
}

int main (int argc, char **argv) {
    int i, max = 0;

    SEED = (unsigned)time(&loadingtime);

    switch (argc) {
    case 2:
        max = (unsigned)atoi(argv[1]);
        break;
    case 3:
        max = (unsigned)atoi(argv[1]);
        SEED = atof(argv[2]); 
        break;
    default:
	Usage(argv[0]); exit (EXIT_FAILURE);
    }
    if (max == 0)     Usage(argv[0]);
    MTsgenrand(SEED);

    fprintf(stdout, "### ProgramName: %s %d %d\n", argv[0], max, SEED);
    fprintf(stdout, "### Creator: Shinichi ASAKAWA <asakawa@twcu.ac.jp>\n");
    (void)time(&loadingtime);
    fprintf(stdout, "### CreationDate: %s", ctime(&loadingtime));

    for (i = 0; i < max; i++) {
	printf("%10.5f\n", exp_rand());
    }
    return EXIT_SUCCESS;
}
#endif STANDALONE
