 /* t$BJ,I[(B */
#include <math.h>
#include "general.h"
#include "rand_gen.h"

double t_rand (double n) 
{
    double a, b, c;

    if (n <= 2.0) 
	return normal_rand() / sqrt(chisq_rand(n) / n);

    do {
	a = normal_rand();
	b = a * a / (n - 2.0);
	c = log(1 - MTgenrand_f()) / (1 - 0.5 * n);
    } while (exp(-b-c) > 1 - b);
    return a / sqrt((1 - 2.0 / n) * (1 - b));
}

/**********************************************************/
#ifdef STANDALONE
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

long loadingtime;
unsigned int SEED = 0;

void Usage (char *prg) {
    fprintf(stderr,"Usage:\n");
    fprintf(stderr,"%s DF N [SEED]\n", prg);
    fprintf(stderr,"options  DF: degree of freedom for t distribution(int)\n");
    fprintf(stderr,"         N: number of data to be generated(int)\n");
    fprintf(stderr,"         SEED: seed of random number(long int)\n");
    exit (EXIT_FAILURE);
}

int main (int argc, char **argv) {
    int i, max = 0;
    double df = 0.0;

    SEED = (unsigned)time(&loadingtime);

    switch (argc) {
    case 3:
        df = atof(argv[1]);
        max = (unsigned)atoi(argv[2]);
        break;
    case 4:	
        df = atof(argv[1]);
        max = (unsigned)atoi(argv[2]);
        SEED = atof(argv[3]); 
        break;
    default:
	Usage(argv[0]); exit (EXIT_FAILURE);
    }
    if (df == 0.0)     Usage(argv[0]);
    if (max == 0)     Usage(argv[0]);
    MTsgenrand(SEED);

    fprintf(stdout, "### ProgramName: %s %g %d %d\n", argv[0], df, max, SEED);
    fprintf(stdout, "### Creator: Shinichi ASAKAWA <asakawa@twcu.ac.jp>\n");
    (void)time(&loadingtime);
    fprintf(stdout, "### CreationDate: %s", ctime(&loadingtime));

    for (i = 0; i < max; i++) {
	printf("%10.5f\n", t_rand(df));
    }
    return EXIT_SUCCESS;
}
#endif STANDALONE
