/* Weibull ($B%o%$%V%k(B) $BJ,I[(B */
#include <math.h>
#include "general.h"
#include "rand_gen.h"

double weibull_rand(double alpha)
{
    return pow(-log(1 - MTgenrand_f()), 1.0 / alpha);
}

/**********************************************************/
#ifdef STANDALONE
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

long loadingtime;
unsigned int SEED = 0;

void Usage (char *prg) {
    fprintf(stderr,"Usage:\n");
    fprintf(stderr,"%s P N [SEED]\n", prg);
    fprintf(stderr,"options  P: parameter for Weibull distribution\n");
    fprintf(stderr,"         N: number of data to be generated(int)\n");
    fprintf(stderr,"         SEED: seed of random number(long int)\n");
    exit (EXIT_FAILURE);
}

int main (int argc, char **argv) {
    int i, max = 0;
    double p = 0.0;

    SEED = (unsigned)time(&loadingtime);

    switch (argc) {
    case 3:
        p = atof(argv[1]);
        max = (unsigned)atoi(argv[2]);
        break;
    case 4:	
        p = atof(argv[1]);
        max = (unsigned)atoi(argv[2]);
        SEED = atof(argv[3]); 
        break;
    default:
	Usage(argv[0]); exit (EXIT_FAILURE);
    }
    if (max == 0)     Usage(argv[0]);
    if (p == 0.0)     Usage(argv[0]);
    MTsgenrand(SEED);

    fprintf(stdout, "### ProgramName: %s %g %d %d\n", argv[0], p, max, SEED);
    fprintf(stdout, "### Creator: Shinichi ASAKAWA <asakawa@twcu.ac.jp>\n");
    (void)time(&loadingtime);
    fprintf(stdout, "### CreationDate: %s", ctime(&loadingtime));

    for (i = 0; i < max; i++) {
	printf("%10.5f\n", weibull_rand(p));
    }
    return EXIT_SUCCESS;
}
#endif STANDALONE
