#include	<stdio.h>
#include	<stdlib.h>
#include	<ctype.h>
#include	<string.h>
#include	<math.h>
#include <pazu.h>

#undef  BUFSIZ
#define BUFSIZ 256
#define N_METHOD 3

void calc_mu2(double *s,double *p,double *nvect,int n,double *L,double *SIGMA);
void calc_uls(double *s,double *p,double *nvect,int n,double *L,double *SIGMA);
void calc_artmean(double *s,double *p,double *nvect,int n,double *L,double *SIGMA);
/*
double *readdata(int *n, char *infile);
void output(unsigned char *outfile,double *tdata, int n, int m,double L, double SIGMA, char *title);
double calc_chi(double *s, double *p, double *nvect,int n, double L, double SIGMA);

void calc_mean(double *data,int n,double *xbar,double *xvar);
void calc_ml1(double *data,int n,double *L,double *SIGMA);
*/

static char tempfile[] = "__@@@@mu.tmp";
static char head1[] = "  ɷ㡡ȿΨ¬";
static char bar[]   = "============================";
static char *prfmt[] = { "  %3.0f ","   %5.2f  ","     %3.0f ", NULL };

struct m_proto {
  int  num;
  char method[80];
  char title[80];
  void (*calc_fun)();
} METHOD[N_METHOD] = {
  { 0, "ARTMEAN","Իʿˡˤ뤤ͤο", calc_artmean},
  { 1, "ULS", "ԺǾˡˤ뤤ͤο" , calc_uls},
  { 2, "MU", "ԥߥ塼顼Хˡˤ뤤ͤο", calc_mu2},
};

double calc_chi(double *s, double *p, double *nvect,int n, double L, double SIGMA)
{
  register int i;
  double ret,phat,temp1,sum = 0.0;
  
  for(i=1;i<=n;i++){
    phat = ( z_to_p((*(s+offs(i,1,n,1)) - L)/SIGMA));
    temp1 = (*(p+offs(i,1,n,1)) - phat) * (*(p+offs(i,1,n,1)) - phat);
    sum += *(nvect+offs(i,1,n,1)) * temp1 / (phat * ( 1.0 - phat));
  }
  ret = sum;
  return(ret);
}

void  output(outfile, tdata, n, m,  L, SIGMA, title)
     unsigned char *outfile;
     double *tdata, L, SIGMA;
     int n, m;
     char *title;

{
  FILE *fo,*fopen();

/*  
  if(strlen(outfile) == 0) fo = stdout;
  else {
    if( (fo = fopen(outfile,"w")) == NULL){
      fprintf(stderr,"file %s can not open\n",outfile);
      exit(1);
    }
  }
*/
  fo = _p_openw(outfile);

  fprintf(fo,"\n%s\n",title);
  fprintf(fo,"\n%s\n",head1);
  fprintf(fo,"%s\n",bar);
  writematf(fo,tdata,n,m, "", "");
/*
  writematf(fo,tdata,n,m, "", prfmt);
*/
  free((void *)tdata);
  
  fprintf(fo,"\nͤο : % 12.5f\n", L);
  fprintf(fo,"      ʬ : % 12.5f\n", SIGMA);
  _p_close (fo);
/*
  if(strlen(outfile) != 0) fclose(fo);
*/
}

int  comp(double *a, double *b)
{
  if((a[0]-b[0]) > 0 ) return(-1);
  else if( (a[0]-b[0]) == 0 ) return(0);
  else return(1);
}

double *readdata(int *n, char *infile)
{
  register int i;
  FILE *fi, *fo, *fopen();
  char buf[BUFSIZ];
  double	*ret;
  
  if((fi = fopen(infile,"r")) == NULL){
    fprintf(stderr,"file %s not found\n",infile);
    exit(1);
  }
  if(fgets(buf,BUFSIZ,fi) == NULL){
    fprintf(stderr,"file %s cannot read\n",infile);
    exit(1);
  }
  *n = atoi(buf);
  if((fo = fopen(tempfile,"w")) == NULL){
    fprintf(stderr,"Error occured! Please connect Asakawa\n");
    exit(1);
  }
  for(i=0;i<*n;i++){
    if(fgets(buf,BUFSIZ,fi) == NULL){
      fprintf(stderr,"Error occured! Please connect Asakawa\n");
      exit(1);
    }
    if(fputs(buf,fo) == EOF){
      fprintf(stderr,"Error occured! Please connect Asakawa\n");
      exit(1);
    }
  }
  fcloseall();
  if((fi = fopen(tempfile,"r")) == NULL){
    fprintf(stderr,"file %s not found\n",tempfile);
    exit(1);
  }
  ret = freadmat(fi,*n,3,0);
  fclose(fi);
  unlink(tempfile);
  qsort((void *)ret,*n,sizeof(double) * 3,comp);
  return(ret);
}

void calc_mu2(double *s, double *p, double *nvect, int n, double *L, double *SIGMA)
{
  double	*zvect, *wvect, *nw, *nws, *nwz;
  double	a, b, nwsum, nwssum, nwzsum;
  double	sbar, zbar, ssz, ss2;
  register int	i;
  
  a = b = nwsum = nwssum = nwzsum = 0.0;
  sbar = zbar = ssz = ss2 = 0.0;
  *L = *SIGMA = 0.0;
  zvect = (double *)calloc(n, sizeof(double));
  wvect = (double *)calloc(n, sizeof(double));
  nw = (double *)calloc(n, sizeof(double));
  nws = (double *)calloc(n, sizeof(double));
  nwz = (double *)calloc(n, sizeof(double));
  
  for(i=0;i<n;i++){
    *(zvect+i) = p_to_z(*(p+i));
    *(wvect+i) = z_to_w(*(zvect+i));
    *(nw+i) = *(wvect+i) * *(nvect+i);
    *(nws+i) = *(s+i) * *(nw+i);
    *(nwz+i) = *(zvect+i) * *(nw+i);
    nwsum += *(nw+i);
    nwssum += *(nws+i);
    nwzsum += *(nwz+i);
  }
  sbar = nwssum / nwsum;
  zbar = nwzsum / nwsum;
  for(i=0;i<n;i++){
    ssz += *(nwz+i) * ( *(s+i) - sbar);
    ss2 += *(nws+i) * ( *(s+i) - sbar);
  }
  b = ssz / ss2;
  a = zbar - b * sbar;
  
  *L = - a / b;
  *SIGMA = 1.0 / b;
  return;
}

void calc_uls(double *s, double *p, double *nvect, int n, double *L, double *SIGMA)
{
  double	*zvect;
  double	sbar, zbar, ssz, ss2;
  register int	i;
  
  sbar = zbar = ssz = ss2 = 0.0;
  *L = *SIGMA = 0.0;
  zvect = matinit(n,1);
  
  for(i=0;i<n;i++){
    *(zvect+i) = p_to_z(*(p+i));
    ss2 += *(s+i) * *(s+i);
    ssz += *(s+i) * *(zvect+i);
    sbar += *(s+i);
    zbar += *(zvect+i);
  }
  sbar /= (double)n;
  zbar /= (double)n;
  *SIGMA = (ss2 - (double)n * sbar * sbar)/ (ssz - (double)n * sbar * zbar);
  
  *L = sbar - zbar * *SIGMA;
  return;
}

void calc_artmean(double *s,double *p,double *nvect,int n,double *L,double *SIGMA)
{
  double	sbar, ss2, ptemp,dp, ln;
  register int	i;
  
  sbar = ss2 = ptemp = dp = 0.0;
  *L = *SIGMA = 0.0;
  
  ln = vecsum(nvect,n,1);
  for(i=n-1;i>=0;i--){
    ptemp = *(p+i) - dp;
    dp = *(p+i);
    sbar += *(nvect+i) * ptemp * *(s+i) / ln;
  }
  *L = sbar;
  dp = 0.0;
  for(i=n-1;i>=0;i--){
    ptemp = *(p+i) - dp;
    dp = *(p+i);
    ss2 += *(nvect+i) * ptemp * (*(s+i)- *L) * (*(s+i)- *L) / ln;
  }
  *SIGMA  = sqrt(ss2);
  return;
}

/*
 * ʲΥץϥǡľܤͤ׻ؿǺ
 * ѤƤʤ
 */
void calc_mean(double *data, int n, double *xbar, double *xvar)
{
  int i;
  double	df;
  
  df = (double)n;
  *xbar = *xvar = 0.0;
  
  for(i=0;i<n;i++){
    *xbar += *(data+i) / df;
  }
  for(i=0;i<n;i++){
    *xvar += (*(data+i) - *xbar) * (*(data+i) - *xbar) / df;
  }
  return;
}

void calc_mu1(double *data, int n, double *L, double *SIGMA)
{
  double	xbar, xvar, xsd, *zvect, *wvect, zbar, sbar, a, b;
  double	ssum, zsum, wsum, nwzss, nwsss;
  int	i;
  
  xbar = xvar = xsd = zbar = sbar = a = b = 0.0;
  ssum = zsum = wsum = nwzss = nwsss = 0.0;
  *L = *SIGMA = 0.0;
  
  zvect = (double *)calloc(n, sizeof(double));
  wvect = (double *)calloc(n, sizeof(double));
  
  calc_mean(data, n, &xbar, &xvar);
  xsd = sqrt(xvar);
  for(i=0;i<n;i++){
    *(zvect+i) = ( *(data+i) - xbar ) / xsd;
    *(wvect+i) = z_to_w( *(zvect+i) );
    ssum += *(wvect+i) * *(data+i);
    zsum += *(zvect+i) * *(wvect+i);
    wsum += *(wvect+i);
  }
  sbar = ssum / wsum;
  zbar = zsum / wsum;
  for(i=0;i<n;i++){
    nwzss += *(wvect+i) * *(zvect+i) * (*(data+i) - sbar);
    nwsss += *(wvect+i) * *(data+i) * (*(data+i) - sbar);
  }
  b = nwzss / nwsss;
  a = zbar - b * sbar;
  *L = -1.0 * a / b;
  *SIGMA = 1.0 / b;
  return;
}

int main(int argc, char **argv)
{
  int	i,n,df, method_number = 2;
  double	X2,probX2, L, SIGMA, *s, *p, *nvect, *tdata;
  char infile[128] = "" , outfile[128] = "";
  
  /* Υå */
  if(argc == 1){
    fprintf(stderr,"usage : mu [-m [MU|ULS] -d <datafile> [-o <outputfile>]\n");
    exit (EXIT_FAILURE);
  }

  while(--argc){
    if(argv[argc][0] == '-'){
      switch(argv[argc][1]){
      case 'd' : strcpy(infile,*(argv+argc+1)); break;
      case 'o' : strcpy(outfile, *(argv+argc+1)); break;
      case 'm' :
	for(i=0;i<N_METHOD;i++)
	  if(strcmp(*(argv+argc+1),METHOD[i].method) == 0)
	    method_number = i;
	break;
      default :
	fprintf(stderr,"unknown option %c - ignored\n", argv[argc][1]);
	exit (EXIT_FAILURE);
      }
    }
  }
  
  tdata =  readdata(&n,infile);
  s = colvec(tdata,n,3,1);
  p = colvec(tdata,n,3,2);
  nvect = colvec(tdata,n,3,3);
  
  (METHOD[method_number].calc_fun)(s, p, nvect, n, &L, &SIGMA);
  X2 = calc_chi(s,p,nvect,n,L,SIGMA);
  probX2 = prob_chisquare( n - 3 , X2);
  printf("chi_square = %f\n",probX2);

  output(outfile,tdata,n,3,L,SIGMA,METHOD[method_number].title);
  return OK;
}
