/*	Calculate the Muller-Urban weight from the probability
 *	usage: p2MUw p
 *		Written by S.Asakawa 1993/05/04
 */
#include <math.h>
#include "general.h"

extern double p2z(double);
extern double z2MUw(double);

/* Ψ p MeullerUbanٽţ */
double p2MUw(double p)
{
  double  z, ret;
  z = p2z(p);
  ret = z2MUw(z);
  return ret;
}

#ifdef TEST
#include        <stdio.h>
#include        <stdlib.h>

void usage(void)
{
  fprintf(stderr,"p_norm: Calculate the probability according with Normal distribution\n");
  fprintf(stderr,"usage:p_norm z\n");
  exit (EXIT_FAILURE);
}

int main( int argc, char **argv )
{
  double z;

  if( argc != 2 ) usage();
  z = atof(argv[1]);

  fprintf(stdout, "%.20g ", p2MUw(z));
  return OK;
}
#endif
