/*	Calculate the probability according with Chi square distribution.
 *	usage: p_chi2 df chi2
 *
 *	compile: tcc -mt -DTEST p_chi2.cpp
 *
 *		Written by S.Asakawa 1993/05/04
 */
#include <math.h>
#include "general.h"

#define Eps 1.0e-20

double p_chi2(int df, double l)
/* ʬۤ˽ΨѿϰϤȤΨ */
{
	double	p,lastp,loggamma,temp;

	loggamma = (df % 2 == 1) ? log(Pi)/2 : 0;
	temp = (double)df / 2.0;
	while(temp > 0.0){
		loggamma += log(temp);
		temp -= 1.0;
	}
	p = temp = exp( (double)df / 2 * log(l / 2.0) - loggamma - l / 2.0);
	do{
		lastp = p;
		df += 2;
		temp *= l / (double)df;
		p += temp;
	} 
	while( fabs(p - lastp) > Eps);
	return p;
}

#ifdef TEST
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>

void usage(void)
{
	fprintf(stderr,"p_chi2: Calculate the probability according with chi square distribution\n");
	fprintf(stderr,"usage:p_chi2 df chi2\n");
	exit(FALSE);
}

int main( int argc, char **argv )
{
	int df;
	double chi2;

	if( argc != 3 )	usage();
	df = atoi(argv[1]);
	chi2 = atof(argv[2]);

	fprintf(stdout,"%4.5f ",p_chi2(df,chi2));
	return TRUE;
}
#endif
